<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/language.oop5.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'ru',
  ),
  'this' => 
  array (
    0 => 'language.oop5.autoload.php',
    1 => 'Автоматическая загрузка классов',
  ),
  'up' => 
  array (
    0 => 'language.oop5.php',
    1 => 'Классы и объекты',
  ),
  'prev' => 
  array (
    0 => 'language.oop5.constants.php',
    1 => 'Константы классов',
  ),
  'next' => 
  array (
    0 => 'language.oop5.decon.php',
    1 => 'Конструкторы и деструкторы',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'ru',
    'path' => 'language/oop5/autoload.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="language.oop5.autoload" class="sect1">
 <h2 class="title">Автоматическая загрузка классов</h2>
 <p class="para">
  Разработчики объектно-ориентированных приложений
  договорились создавать по одному исходному PHP-файлу для каждого класса.
  Главная неприятность — приходится в начале каждого скрипта
  писать длинный список включений, по одному для каждого файла,
  который требуется загрузить.
 </p>
 <p class="para">
  Функция <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span>
  регистрирует нужное количество автозагрузчиков
  для автоматической загрузки классов и интерфейсов,
  которые пока не определили.
  Регистрация автозагрузчиков даёт PHP последний шанс загрузить класс
  или интерфейс, прежде чем скрипт завершит работу с ошибкой.
 </p>
 <p class="para">
  Все классоподобные конструкции получится загрузить автоматически таким же способом,
  включая классы, интерфейсы, трейты и перечисления.
 </p>
 <div class="caution"><strong class="caution">Предостережение</strong>
  <p class="para">
   До PHP 8.0.0 классы и интерфейсы загружали автоматически
   функцией <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span>.
   Однако это менее гибкая альтернатива функции
   <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span>,
   а функцию <span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span> объявили устаревшей в PHP 7.2.0
   и удалили в PHP 8.0.0.
  </p>
 </div>
 <blockquote class="note"><p><strong class="note">Замечание</strong>: 
  <p class="para">
   Функцию <span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span> разрешается
   вызывать больше одного раза, чтобы зарегистрировать больше одного автозагрузчика.
   Если функция автозагрузки выбросит исключение,
   оно прервёт процесс автозагрузки и не разрешит запускать следующие функции автозагрузки.
   Поэтому выбрасывать исключения из функции автозагрузки настоятельно не рекомендуется.
  </p>
 </p></blockquote>
 <p class="para">
  <div class="example" id="example-262">
   <p><strong>Пример #1 Пример автоматической загрузки классов</strong></p>
   <div class="example-contents"><p>
    В этом примере функция пытается загрузить класс <code class="literal">MyClass1</code>
    из файла <var class="filename">MyClass1.php</var> и класс <code class="literal">MyClass2</code>
    из файла <var class="filename">MyClass2.php</var>.
   </p></div>
   <div class="example-contents">
<div class="annotation-interactive phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /><br />spl_autoload_register</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$class_name</span><span style="color: #007700">) {<br />    include </span><span style="color: #0000BB">$class_name </span><span style="color: #007700">. </span><span style="color: #DD0000">'.php'</span><span style="color: #007700">;<br />});<br /><br /></span><span style="color: #0000BB">$obj  </span><span style="color: #007700">= new </span><span style="color: #0000BB">MyClass1</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">$obj2 </span><span style="color: #007700">= new </span><span style="color: #0000BB">MyClass2</span><span style="color: #007700">();<br /><br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

   </div>
   <div class="example" id="example-263">
    <p><strong>Пример #2 Другой пример автоматической загрузки классов</strong></p>
    <div class="example-contents"><p>
     В этом примере функция пытается загрузить интерфейс <code class="literal">ITest</code>.
    </p></div>
    <div class="example-contents">
<div class="annotation-interactive phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /><br />spl_autoload_register</span><span style="color: #007700">(function (</span><span style="color: #0000BB">$name</span><span style="color: #007700">) {<br />    </span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">$name</span><span style="color: #007700">);<br />});<br /><br />class </span><span style="color: #0000BB">Foo </span><span style="color: #007700">implements </span><span style="color: #0000BB">ITest </span><span style="color: #007700">{}<br /><br /></span><span style="color: #FF8000">/*<br />string(5) "ITest"<br /><br />Fatal error: Interface 'ITest' not found in ...<br />*/<br /><br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

   </div>
   <div class="example" id="example-264">
    <p><strong>Пример #3 Пример работы с автозагрузчиком пакетного менеджера Composer</strong></p>
    <div class="example-contents"><p>
     <a href="https://getcomposer.org/" class="link external">&raquo;&nbsp;Composer</a> генерирует файл <code class="literal">vendor/autoload.php</code>,
     который настраивается на автоматическую загрузку пакетов,
     которыми управляет менеджер зависимостей. Пакеты готовы к работе
     сразу после включения файла-автозагрузчика.
    </p></div>
    <div class="example-contents">
<div class="annotation-interactive phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /><br /></span><span style="color: #007700">require </span><span style="color: #0000BB">__DIR__ </span><span style="color: #007700">. </span><span style="color: #DD0000">'/vendor/autoload.php'</span><span style="color: #007700">;<br /><br /></span><span style="color: #0000BB">$uuid </span><span style="color: #007700">= </span><span style="color: #0000BB">Ramsey\Uuid\Uuid</span><span style="color: #007700">::</span><span style="color: #0000BB">uuid7</span><span style="color: #007700">();<br /><br />echo </span><span style="color: #DD0000">"Пакет сгенерировал новый UUID-идентификатор -&gt; "</span><span style="color: #007700">, </span><span style="color: #0000BB">$uuid</span><span style="color: #007700">-&gt;</span><span style="color: #0000BB">toString</span><span style="color: #007700">(), </span><span style="color: #DD0000">"\n"</span><span style="color: #007700">;<br /><br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

   </div>
  </p>

  <div class="simplesect">
   <h3 class="title">Смотрите также</h3>
   <p class="para">
    <ul class="simplelist">
     <li><span class="function"><a href="function.unserialize.php" class="function">unserialize()</a></span></li>
     <li><a href="var.configuration.php#ini.unserialize-callback-func" class="link">unserialize_callback_func</a></li>
     <li><a href="var.configuration.php#ini.unserialize-max-depth" class="link">unserialize_max_depth</a></li>
     <li><span class="function"><a href="function.spl-autoload-register.php" class="function">spl_autoload_register()</a></span></li>
     <li><span class="function"><a href="function.spl-autoload.php" class="function">spl_autoload()</a></span></li>
     <li><span class="function"><a href="function.autoload.php" class="function">__autoload()</a></span></li>
    </ul>
   </p>
  </div>

</div><?php manual_footer($setup); ?>